[{
    Name: "Programmable Thermostat Widget",
    Author: "David VINET",
    Version: "2015-11-22",

    GroupName: '',
    IconImage: 'pages/control/widgets/homegenie/generic/images/temperature.png',
    StatusText: '',
    Description: '',
  	Module:'',
    ControlPopupTable:'',
    ControlPopupSetPoint:'',
    TimebarResolution: 5,
    TimebarWidth: 530,
    TimebarHeight: 40,
    TimeBarEl: null,
    CurrentSlice: null,
  
    TempColor: {
      '5':'#0500ff',
      '5.5':'#0400ff',
      '6':'#0300ff',
      '6.5':'#0200ff',
      '7':'#0100ff',
      '7.5':'#0000ff',
      '8':'#0002ff',
      '8.5':'#0012ff',
      '9':'#0022ff',
      '9.5':'#0032ff',
      '10':'#0044ff',
      '10.5':'#0054ff',
      '11':'#0064ff',
      '11.5':'#0074ff',
      '12':'#0084ff',
      '12.5':'#0094ff',
      '13':'#00a4ff',
      '13.5':'#00b4ff',
      '14':'#00c4ff',
      '14.5':'#00d4ff',
      '15':'#00e4ff',
      '15.5':'#00fff4',
      '16':'#00ffd0',
      '16.5':'#00ffa8',
      '17':'#00ff83',
      '17.5':'#00ff5c',
      '18':'#00ff36',
      '18.5':'#00ff10',
      '19':'#17ff00',
      '19.5':'#3eff00',
      '20':'#65ff00',
      '20.5':'#8aff00',
      '21':'#b0ff00',
      '21.5':'#d7ff00',
      '22':'#fdff00',
      '22.5':'#FFfa00',
      '23':'#FFf000',
      '23.5':'#FFe600',
      '24':'#FFdc00',
      '24.5':'#FFd200',
      '25':'#FFc800',
      '25.5':'#FFbe00',
      '26':'#FFb400',
      '26.5':'#FFaa00',
      '27':'#FFa000',
      '27.5':'#FF9600',
      '28':'#FF8c00',
      '28.5':'#FF8200',
      '29':'#FF7800',
      '29.5':'#FF6e00',
      '30':'#FF6400',
      '30.5':'#FF5a00',
      '31':'#FF5000',
      '31.5':'#FF4600',
      '32':'#FF3c00',
      '32.5':'#FF3200',
      '33':'#FF2800',
      '33.5':'#FF1e00',
      '34':'#FF1400',
      '34.5':'#FF0a00',
      '35':'#FF0000',
      '35.5':'#FF0010',
      '36':'#FF0020',
      '36.5':'#FF0030',
      '37':'#FF0040',
      '37.5':'#FF0050',
      '38':'#FF0060',
      '38.5':'#FF0070',
      '39':'#FF0080',
      '39.5':'#FF0090',
      '40':'#FF00A0',
      '40.5':'#FF00B0',
      '41':'#FF00C0',
      '41.5':'#FF00D0',
      '42':'#FF00E0',
      '42.5':'#FF00F0',
      '43':'#FF01F0',
      '43.5':'#FF02F0',
      '44':'#FF03F0',
      '44.5':'#FF04F0',
      '45':'#FF05F0',
      '45.5':'#FF06F0',
      '46':'#FF07F0',
      '46.5':'#FF08F0',
      '47':'#FF09F0',
      '47.5':'#FF0AF0',
      '48':'#FF0BF0',
      '48.5':'#FF0CF0',
      '49':'#FF0DF0',
      '49.5':'#FF0EF0'
    },
  
  	_initialized: false,

    RenderView: function (cuid, module) {
        var container = $(cuid);
        var widget = container.find('[data-ui-field=widget]');
		var _this = this;

      	if (!this._initialized) {
			var displayUnit = 'Celsius';
			if (HG.WebApp.Locales.GetDateEndianType() == 'M') displayUnit = 'Fahrenheit';
          	this.Module=module;
          	this.ControlPopupTable = container.find('[data-ui-field=controlpopuptable]').popup();
			this.ControlPopupTable.trigger('create');
			this.ControlPopupSetPoint = container.find('[data-ui-field=controlpopupsetpoint]').popup();
			this.ControlPopupSetPoint.trigger('create');
          
          	if (displayUnit == 'Celsius') {
                widget.find('[data-ui-field=setpoint_knob]').trigger('configure', {
                    min: 5,
                    max: 35.1
                });
              	this.ControlPopupSetPoint.find('[data-ui-field=setpoint_knob]').trigger('configure', {
                    min: 5,
                    max: 35.1
                });
           }
           else {
                widget.find('[data-ui-field=setpoint_knob]').trigger('configure', {
                    min: 40,
                    max: 100.1
                });
             	this.ControlPopupSetPoint.find('[data-ui-field=setpoint_knob]').trigger('configure', {
                    min: 40,
                    max: 100.1
                });
        	}
			
			widget.find('[data-ui-field=options]').on('click', function () {
                _this.ControlPopupTable.popup('open');
            });
			
			// settings button
            widget.find('[data-ui-field=settings]').on('click', function () {
                if (module.Domain == 'HomeAutomation.HomeGenie.Automation') {
                    HG.WebApp.ProgramEdit._CurrentProgram.Domain = module.Domain;
                    HG.WebApp.ProgramEdit._CurrentProgram.Address = module.Address;
                    HG.WebApp.ProgramsList.UpdateOptionsPopup();
                }
                else {
                    HG.WebApp.Control.EditModule(module);
                }
            });
			
			widget.find('[data-ui-field=setpoint_knob]').knob({
                'release': function (v) {
                    v = Math.round(v * 10) / 10;
                    var setPoint = HG.WebApp.Utility.GetModulePropertyByName(module, 'Thermostat.SetPoint.Current');
                    if (setPoint != null) setPoint.Value = v;
                    HG.Control.Modules.ServiceCall('Thermostat.SetPointSet/Current' , module.Domain, module.Address, v, function (data) { });
                },
              	//'format' : function (value) {
     			//	return "aa";//value + '°C';
                //},
                'draw': function () {
                $(this.i).val(this.cv + '°C');
                }
            });
          
          	this.ControlPopupSetPoint.find('[data-ui-field=setpoint_knob]').knob({
                'release': function (v) {
                    v = Math.round(v * 10) / 10;
                },
              	//'format' : function (value) {
     			//	return "aa";//value + '°C';
                //},
                //'draw': function () {
                //$(this.i).val(this.cv + '°C');
                //}
            });
          
          	this.ControlPopupSetPoint.find('[data-ui-field=btn_timeslot_set]').click(function(el){
        	  var slotFrom = _this.ControlPopupSetPoint.find('[data-ui-field=select_timestart]').val();
        	  var slotTo = _this.ControlPopupSetPoint.find('[data-ui-field=select_timeend]').val();
              //var slotValue = _this.ControlPopupSetPoint.find('[data-ui-field=select_action]').val();
              var setpointValue = _this.ControlPopupSetPoint.find('[data-ui-field=setpoint_knob]').val();
              $.mobile.loading('show', { text: 'Saving table', textVisible: true });
              HG.Control.Modules.ServiceCall('Thermostat.SetPointTableSet/'+slotFrom+'.'+slotTo, module.Domain, module.Address, setpointValue, function (data) 
              { 
              	_this.SetTable(_this.TimeBarEl);
              	_this.ControlPopupSetPoint.popup('close');
              });
              /*var request = slotFrom + '.' + slotTo + '/' + setpointValue;
              $.mobile.loading('show', { text: 'Saving table', textVisible: true });
              $.ajax({
                  url: '/' + HG.WebApp.Data.ServiceKey + '/' + _this.Module.Domain + '/' + _this.Module.Address + '/Thermostat.SetPointTableSet',
                  type: 'POST',
                  data: request,
                  dataType: 'text',
                  success: function (data) {
                      _this.SetTable(_this.TimeBarEl);
              		  _this.ControlPopupSetPoint.popup('close');
                  }
              });*/
              //_this.SetTable(_this.TimeBarEl);
              //_this.ControlPopupSetPoint.popup('close');
            });
          	
          	//force the timetable popup to appear after the setpoint popup close
          	this.ControlPopupSetPoint.on('popupafterclose', function (evt, ui) {
              _this.ControlPopupTable.popup('open');
            });          	
			
			// popup values on open
			var controlpopup = this.ControlPopupTable
            controlpopup.on('popupbeforeposition', function (evt, ui) {
                // reset buttons' state
                controlpopup.find('[data-ui-field=mode_off]').addClass('ui-btn-active');
                controlpopup.find('[data-ui-field=mode_auto]').removeClass('ui-btn-active');

                // set current buttons' state from module properties 
                // thermostat mode
                var thermostatMode = HG.WebApp.Utility.GetModulePropertyByName(module, 'Thermostat.Mode');
                if (thermostatMode != null) {
                    if (thermostatMode.Value == 'Off') {
                        controlpopup.find('[data-ui-field=mode_off]').addClass('ui-btn-active');
                        controlpopup.find('[data-ui-field=mode_heat]').removeClass('ui-btn-active');
                    }
                    else if (thermostatMode.Value == 'Auto') {
                        controlpopup.find('[data-ui-field=mode_off]').removeClass('ui-btn-active');
                        controlpopup.find('[data-ui-field=mode_auto]').addClass('ui-btn-active');
                    }
                }
                controlpopup.find('[data-ui-field=mode_off]').on('click', function () {
					controlpopup.find('[data-ui-field=mode_off]').addClass('ui-btn-active');
					controlpopup.find('[data-ui-field=mode_frost]').removeClass('ui-btn-active');
					controlpopup.find('[data-ui-field=mode_auto]').removeClass('ui-btn-active');
					HG.Control.Modules.ServiceCall("Thermostat.ModeSet", module.Domain, module.Address, "Off", function (data) { });
				});
				controlpopup.find('[data-ui-field=mode_auto]').on('click', function () {
					controlpopup.find('[data-ui-field=mode_off]').removeClass('ui-btn-active');
					controlpopup.find('[data-ui-field=mode_frost]').removeClass('ui-btn-active');
					controlpopup.find('[data-ui-field=mode_auto]').addClass('ui-btn-active');
					HG.Control.Modules.ServiceCall("Thermostat.ModeSet", module.Domain, module.Address, "Auto", function (data) { });
				});
				controlpopup.find('[data-ui-field=mode_frost]').on('click', function () {
					controlpopup.find('[data-ui-field=mode_off]').removeClass('ui-btn-active');
					controlpopup.find('[data-ui-field=mode_frost]').addClass('ui-btn-active');
					controlpopup.find('[data-ui-field=mode_auto]').removeClass('ui-btn-active');
					HG.Control.Modules.ServiceCall("Thermostat.ModeSet", module.Domain, module.Address, "Frost", function (data) { });
				});
              
              	_this.SetTable(_this.TimeBarEl);
            });
			
			this.TimeBarEl = controlpopup.find('[data-ui-field=timebar_s]');
      		this.TimeBarEl.paper = Raphael(this.TimeBarEl.get(0), this.TimebarWidth, this.TimebarHeight);
			
          	_this._initialized = true;
        }
        
        this.Description = (module.Domain.substring(module.Domain.lastIndexOf('.') + 1)) + ' ' + module.Address;

        widget.find('[data-ui-field=name]').html(module.Name);
        widget.find('[data-ui-field=description]').html(this.Description);
        this.ControlPopupTable.find('[data-ui-field=group]').html(this.GroupName);
        this.ControlPopupTable.find('[data-ui-field=name]').html(module.Name);

        var imagesrc = 'pages/control/widgets/homegenie/generic/images/temperature.png';
      	
        // display status icon and status line (operating state + mode)
        var displayState = '---';
        var operatingState = HG.WebApp.Utility.GetModulePropertyByName(module, "Thermostat.OperatingState");
      	if (operatingState.Value=="Heating") widget.find('[data-ui-field=heat_field]').show();
        else widget.find('[data-ui-field=heat_field]').hide();
        if (operatingState != null) displayState = operatingState.Value;
        widget.find('[data-ui-field=operating_value]').html(displayState);
      
        //
        var displayMode = '---';
        var operatingMode = HG.WebApp.Utility.GetModulePropertyByName(module, "Thermostat.Mode");
        if (operatingMode != null) displayMode = operatingMode.Value;
        widget.find('[data-ui-field=mode_value]').html(displayMode);   
      
      	_this.EditWidgetSetPoint(widget, module);

    },
  
  	EditWidgetSetPoint: function (widget, module) {
        var levelKnob = widget.find('[data-ui-field=setpoint_knob]');
        // show current heat setpoint
        var currentSetPoint = HG.WebApp.Utility.GetModulePropertyByName(module, 'Thermostat.SetPoint.Current');
        if (currentSetPoint != null) {
            levelKnob.val(currentSetPoint.Value).trigger('change');
        }
    },
  
  	EditPopupSetPoint: function (popup, setValue) {
        var levelKnob = popup.find('[data-ui-field=setpoint_knob]');
        levelKnob.val(setValue).trigger('change');
    },
  
  	SetTable: function(el) {
    el.paper.clear();
    var _this = this;
    $.mobile.loading('show', { text: 'Loading table', textVisible: true });
    var table = HG.WebApp.Utility.GetModulePropertyByName(_this.Module, 'Thermostat.SetPointTable');
    this.DrawTimetable(el, true, table);
    $.mobile.loading('hide');
    
  },
  
  	DrawTimetable: function(el, drawHeader, table) {
    var _this = this;
    var paper = el.paper;
    var timetable = ['0'];
    paper.clear();
    paper.rect(0, 0, this.TimebarWidth, this.TimebarHeight, 0).attr({fill: "#000", stroke: "none"});
    var tableIndexCount = 24 * 60 / this.TimebarResolution;
    var sliceFactor = (60 / this.TimebarResolution);
    if (table != null) timetable = table.Value.split(';');
    var updateTable = false;
    while (timetable.length < tableIndexCount) timetable[timetable.length] = '0';  
    var nb = 0, x = 0, y = 0, startIndex = 0;
    var stepSize = (_this.TimebarWidth / timetable.length);
    var startY = drawHeader ? 14 : 0;
    for (var i = 0, c = timetable.length; i < tableIndexCount; i++)
    {
      nb++;
      if ((i == (tableIndexCount - 1)) || (timetable[i + 1] != timetable[i])) 
      {
        //TODO : if Farenheit, need to convert setpoint to celcius in order to get the rigth color from the table
        var rect = paper.rect(x, y + startY, (nb * stepSize) - 1, _this.TimebarHeight - (startY+1)).attr({ 'fill': '90-#455-' + _this.TempColor[timetable[i]]/*'#222'*/, 'stroke': '#fff', 'stroke-width': '0.0' })
        .mouseover(function(e){
          this.attr({ 'stroke': '#5f5', 'stroke-width': '2', 'stroke-opacity' : 0.7 });
          _this.CurrentSlice = this;
        })
        .mouseout(function(e){
          this.attr({ 'stroke': '#fff', 'stroke-width': '0.0' });
        })
        .click(function(e){
          _this.EditTimetable(el, this.data('index'), this.data('length'), this.data('setpoint'));
        });
        //rect.data('group', el.group);
        rect.data('index', startIndex);
        rect.data('length', nb);
        rect.data('setpoint', timetable[i]);
        //
        var centerX = (nb * stepSize) / 2;
        $(rect.node).qtip({ 
            content: _this.GetSliceInfo(rect),
            show: { delay: 350 },
            style: { classes: 'qtip-red qtip-shadow qtip-rounded qtip-bootstrap' },
            position: { my: 'bottom center', at: 'top right', adjust: { x: centerX, y: -10 } }
        });
        //
        x += nb * stepSize;
        nb = 0;
        startIndex = i + 1;
      }
      if (drawHeader && i % sliceFactor == 0)
      {
        paper.text(((i / sliceFactor) * (sliceFactor * stepSize)) + 10, 8, (i / sliceFactor).toString()).attr({ fill: '#fff' });
        paper.rect(((i / sliceFactor) * (sliceFactor * stepSize)) + (stepSize * sliceFactor), 0, 2, 16, 0).attr({ fill: '#99f' });
      }
    }
    },
  	
  	GetSliceInfo: function(rect) {
    var setpoint = rect.data('setpoint');
    var start = rect.data('index');
    var end = start + rect.data('length');
    var info = '';
    //if (action != null)
    //{
        info = '<strong>' + setpoint + '</strong>';
        info += ' ' + HG.WebApp.Locales.GetWidgetLocaleString(this.Widget, 'timetable_hour_from', 'from');
        info += ' <strong>' + this.GetSliceTime(start) + '</strong>';
        info += ' ' + HG.WebApp.Locales.GetWidgetLocaleString(this.Widget, 'timetable_hour_to', 'to');
        info += ' <strong>' + this.GetSliceTime(end) + '</strong>';
    //}
    return info;
  },
  
  GetSliceTime: function(sliceIndex) {
      var sliceSize = (60 / this.TimebarResolution);
      var hour = Math.floor(sliceIndex / sliceSize);
      var minute = Math.round(((sliceIndex / sliceSize) - hour) * 60);
      if (hour.toString().length == 1) hour = '0' + hour;
      if (minute.toString().length == 1) minute = '0' + minute;
      return hour + ':' + minute;
  },
  
  EditTimetable: function(el, start, length, setpoint) {
    var selectStart = this.ControlPopupSetPoint.find('[data-ui-field=select_timestart]');
    var selectEnd = this.ControlPopupSetPoint.find('[data-ui-field=select_timeend]');
    selectStart.empty();
    selectEnd.empty();
    var tableLength = 24 * 60 / this.TimebarResolution;
    for (var i = 0; i <= tableLength; i++)
    {
      var displayTime = this.GetSliceTime(i);
      selectStart.append('<option value="' + i + '"' + (i == start ? ' selected' : '') + '>' + displayTime + '</option>');
      selectEnd.append('<option value="' + i + '"' + (i == (start + length) ? ' selected' : '') + '>' + displayTime + '</option>');
    }
    selectStart.selectmenu('refresh', true);
    selectEnd.selectmenu('refresh', true);
    this.EditPopupSetPoint(this.ControlPopupSetPoint,setpoint)
    HG.WebApp.Utility.SwitchPopup(this.ControlPopupTable, this.ControlPopupSetPoint, false);
  }
  
}]
